<?php
/**************************************************
  Coppermine 1.5.x Plugin - short_comments
  *************************************************
  Copyright (c) 2011 Pierre BASMOREAU
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ********************************************
  $HeadURL: 
  $Revision: 
  $LastChangedBy: 
  $Date: 2011/08/29
  **************************************************/
 
if (!defined('IN_COPPERMINE')) { 
    die('Not in Coppermine...');
}
if (!defined('PLUGINMGR_PHP')) {
	define('PLUGINMGR_PHP', true);
}
if (!defined('ADMIN_PHP')) {
    define('ADMIN_PHP', true);
}
if (!defined('CORE_PLUGIN')) {
    define('CORE_PLUGIN', true);
}

// Add plugin_cleanup action
$thisplugin->add_action('plugin_cleanup','short_comments_cleanup');
// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','short_comments_uninstall');
// Add plugin_install action
$thisplugin->add_action('plugin_install','short_comments_install');
// Add filter to display comments
$thisplugin->add_filter('theme_display_thumbnails_params','short_comments');
// Add filter for page head
$thisplugin->add_filter('page_meta','short_comments_head');


/********************************************************************
Insert style
********************************************************************/
function short_comments_head($meta)
{
	$meta  .= <<< EOT
	<!-- BEGIN style for short_comments -->
    <link rel="stylesheet" href="plugins/short_comments/style.css" type="text/css" />
	<!-- END style for short_comments -->\n
EOT;
	return $meta;
}

/********************************************************************
Makes short comment if needed
********************************************************************/
function short_comments($params)
{
	GLOBAL $lang_plugin_short_comments, $CONFIG, $row;
	require ('./plugins/short_comments/include/init.inc.php');

	$maxwords = $CONFIG['plugin_short_comments_maxwords'];

	// Extract comments for each picture
	$caption_text = $params['{CAPTION}'];
	
	$p1 = strrpos($caption_text, "<span class=\"thumb_caption\">");
	
	if ($p1 == true) {
		$p2 = strrpos($caption_text, "</span>", $p1 + strlen("<span class=\"thumb_caption\">"));
		//echo $p1.' '.$p2. '->' . substr($caption_text, $p1, $p2-$p1) . "<br>";
		$comment = substr($caption_text, $p1 + strlen("<span class=\"thumb_caption\">"), $p2-$p1);
		$words = explode(" ",$comment,$maxwords+1);
		$nbwords = count($words);
		$words[$maxwords] = "";
		$msg_suite = '';

		if ($nbwords-1 == $maxwords) {
			//Link to view picture and entire comment
			$msg_suite = '<span class="thumb_caption_suite">' . '<a href=' . $params['{LINK_TGT}'] . '>' .$lang_plugin_short_comments['more'] . '</a>...</span>';
			$comment = implode(" ",$words);
		}
		$comment = "<span class=\"thumb_caption\">" . $comment . $msg_suite . '</span>';
		$params['{CAPTION}'] = substr($caption_text, 0, $p1) . $comment;
	}
	return $params;
}

/********************************************************************
Uninstall plugin
********************************************************************/
function short_comments_uninstall()
{
	global $CONFIG;
	$short_comments_superCage = Inspekt::makeSuperCage();

	if (!$short_comments_superCage->post->keyExists('drop')) {
		return 1;
	}
	// Drop the infos configuration
	if ($short_comments_superCage->post->getInt('drop') == 1) {
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_PREFIX']}config WHERE name LIKE 'plugin_short_comments_%'");
	}
	return true;
}

/********************************************************************
Ask if we want to drop the table
********************************************************************/
function short_comments_cleanup($action) {

    global $lang_plugin_short_comments, $CONFIG;
	require_once('./plugins/short_comments/include/init.inc.php');

    $short_comments_superCage = Inspekt::makeSuperCage();
    $cleanup = $short_comments_superCage->server->getEscaped('REQUEST_URI');

    if ($action===1) {
    echo <<< EOT
    <form action="{$cleanup}" method="post">
        <table border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td class="tableb">
                    {$lang_plugin_short_comments['short_comments_remove']}
                </td>
                <td class="tableb">
                    <input type="radio" name="drop" id="drop_yes" value="1" />
                    <label for="drop_yes" class="clickable_option">{$lang_plugin_short_comments['yes']}</label>
                </td>
                <td class="tableb">
                    <input type="radio" name="drop" id="drop_no" checked="checked" value="0" />
                    <label for="drop_no" class="clickable_option">{$lang_plugin_short_comments['no']}</label>
                </td>
                <td class="tableb">
                    <input type="submit" name="submit" value="{$lang_plugin_short_comments['submit_button']}">
                </td>
            </tr>
        </table>
    </form>
EOT;
    }
}

/********************************************************************
Install plugin
********************************************************************/
function short_comments_install()
{
	global $CONFIG, $thisplugin, $lang_plugin_short_comments;
	//Create fields in TABLE_CONFIG if not exists
	if (!$CONFIG['plugin_short_comments_nwords']) {
		$sql = "INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} values ('plugin_short_comments_maxwords','15')";
		cpg_db_query($sql);
	}
	return true;
}
?>